{% macro getForm(data, title='') %}
    {% import _self as forms %}

    <form id="formCategori">
        <input id="id" name="id" hidden>
        <input id="action" name="action" hidden>
        <div class="modal-header">
            <h5 class="modal-title" id="exampleModalLongTitle">Form {{ title }}</h5>
            <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                <span aria-hidden="true">&times;</span>
            </button>
        </div>
        <div class="modal-body">
            {% for field in data %}
                {{ forms.getField(field) }}
            {% endfor %}
        </div>

        <div class="modal-footer">
            <button type="button" class="btn btn-secondary" data-dismiss="modal">Close</button>
            <button type="submit" class="btn btn-primary">Simpan</button>
        </div>
    </form>
{% endmacro %}

{% macro getField(field) %}
    {% set status = {
        0: {"label" :"Aktif", 'value' : 1},
        1 :  {"label" : "Tidak Aktif", 'value' : 0},
    } %}

    {% if field['type'] is defined and field['type'] == 'image' %}
        <div class="form-group col-md-12">
            <label for="subjek">Icon : </label>
            <div class="input-field" id="div-img">
                <input name='{{ field['name'] }}' type="file" onchange="" id="icon" class="icon" data-min-height="10"
                       data-height="150"
                       accept="image/jpeg, image/jpg, image/png"
                       data-allowed-file-extensions="jpg jpeg png"
                />
            </div>
        </div>
    {% elseif field['type'] is defined and field['type'] == 'combobox' %}
        <div class="form-group col-md-12">
            <select name='{{ field['name'] }}' id="{{ field['name']|lower }}" class="custom-select custom-select">
                {% if field['data'] is defined %}
                    {% for option in field['data'] %}
                        <option value="{{ option['value'] }}">{{ option['label'] }}</option>
                    {% endfor %}
                {% else %}
                    {% for option in status %}
                        <option value="{{ option['value'] }}">{{ option['label'] }}</option>
                    {% endfor %}
                {% endif %}

            </select>
        </div>
    {% elseif field['type'] is defined and field['type'] == 'hidden' %}
        <div class="form-group col-md-12">
            <input type="text" class="d-none" value="{{ field['data'] }}" name="{{ field['name'] }}"
                   id="{{ field['name']|lower }}"/>
        </div>
    {% else %}


        <div class="form-group col-md-12">
            <label for="subjek">{{ field['label'] }} : </label>
            <input type="text" class="form-control" id="{{ field['name']|lower }}" name='{{ field['name'] }}'
                   placeholder="{{ field['label'] }}">
        </div>
    {% endif %}
{% endmacro %}

{% macro getFormJS() %}
    <script>
        var fr = $('#formCategori');
        fr.submit(async function (e) {
            e.preventDefault(e);
            var formData = new FormData(this);

            alertify.confirm("Tambah Data ", "Apakah data yang anda masukkan sudah benar ?",
                async function () {
                    // if ($('#modal #icon').val()) {
                    //     let icon = await handleImageUpload($('#icon'));
                    //     var name = $('#modal #icon').attr('name');
                    //     formData.append(name, icon, icon.name);
                    // }
                    // console.log(formData);

                    $.ajax({
                        type: "POST",
                        success: function (data) {
                            window.location.reload();
                        },
                        error: function (error) {
                            console.log("LOG ERROR", error);
                            // handle error
                        },
                        async: true,
                        data: formData,
                        cache: false,
                        contentType: false,
                        processData: false,
                        timeout: 60000
                    })
                }, function () {

                }
            )


        });

        function modalAdd() {
            $('#modal #id').val('');
            $('#modal #action').val('add');
            $('#modal #name').val('');
            if ($('.icon').length) {
                var icon = $('.icon').dropify({
                    defaultFile: '',
                    messages: {
                        'default': 'Masukkan Gambar Icon',
                        'replace': 'Drag and drop or click to replace',
                        'remove': 'Remove',
                        'error': 'Ooops, something wrong happended.'
                    }
                });

                icon = icon.data('dropify');
                icon.resetPreview();
                icon.clearElement();
            }
            $("form").trigger("reset");
            $('#modal').modal();
        }

        $(document).on('click', 'a#editData', function () {
            var data = $(this).data();

            if ($('.icon').length) {
                var icon = $('.icon').dropify({
                    defaultFile: '',
                    messages: {
                        'default': 'Masukkan Gambar Icon',
                        'replace': 'Drag and drop or click to replace',
                        'remove': 'Remove',
                        'error': 'Ooops, something wrong happended.'
                    }
                });
                icon = icon.data('dropify');
                icon.resetPreview();
                icon.clearElement();
                icon.settings.defaultFile = $(this).data('icon');
                icon.destroy();
                icon.init();
            }

            Object.keys(data).map(function (key, index) {
                if (key !== 'icon') {
                    $("#modal #" + key + " ").val(data[key]);
                }
            });

            // $('#modal #action').val('edit');
            // $('#modal #title').val($(this).data('title'));
            // $('#modal #level').val($(this).data('level'));
            // $('#modal #category').val($(this).data('cat'));
            // $("#modal [name='description'] ").val($(this).data('description'));
            // $("#modal [name='isActive'] ").val($(this).data('status'));
            // $("#modal [name='codeAccess']").val($(this).data('code'));
            // $("#modal [name='direction']").val($(this).data('direction'));
            // $("#modal [name='rules']").val($(this).data('rules'));
            // $("#modal [name='restTime']").val($(this).data('rest'));
            // $("#modal [name='isStrict']").val($(this).data('strict'));
            // if ($(this).data('free') == 1) {
            //     $("#isFreeTrue").attr("checked", "checked")
            // } else {
            //     $("#isFreeFalse").attr("checked", "checked")
            // }

            $('#modal #id').val($(this).data('cred'));


            $('#modal').modal();
        });
    </script>

{% endmacro %}

{% macro ajaxCall(fetch, url, method) %}
    <script src="{{ asset('js/wkwkwk.js') }}"></script>

    <script>
        (function () {


            $("body").append(
                '<div class="modal fade" id="modalLoading" tabindex="-1" role="dialog" aria-labelledby="exampleModalCenterTitle" aria-hidden="true">\n' +
                '        <div class="modal-dialog modal-dialog-centered" role="document" style="max-width: 50%">\n' +
                '            <div class="modal-content" id="alert">\n' +
                '            </div>\n' +
                '        </div>\n' +
                '    </div>'
            );
            $.ajax({
                    url: "{{ url }}",
                    method: "{{ method }}",
                    beforeSend: function (xhr) {
                        genLoading();
                    },
                    success: function (resultList) {
                        if (resultList['code'] === 200) {
                            if (resultList['payload']['data'] != null) {
                                window["{{ fetch }}"](resultList['payload']['data']);
                                genLoadingDestroy();
                            } else {
                                genLoadingShowError("Oops, data tidak tersedia untuk saat ini");
                            }
                        } else {
                            genLoadingShowError(resultList['msg']);
                        }
                        // console.log(resultList);
                    }
                }
            );
        })();
    </script>
{% endmacro %}